import React, { Component } from 'react';
import { connect } from 'react-redux'
import { withTranslation } from 'react-i18next';
import { withRouter } from 'react-router-dom';
import i18n from 'i18next';
import config from '../config';

import { setDarkMode, getNotifications } from '../store/actions/all';
import { logOut, currentUser } from '../store/actions/auth';

import feedServices from '../services/feed';

import { Button, Layout, Menu, Icon, Typography, Divider, Drawer, List, Tag, Dropdown, Badge, Breadcrumb, Empty } from 'antd';
import '../scss/layout.scss';

import { Link } from 'react-router-dom';
import Avatar from 'react-avatar';
import SocketIO from 'socket.io-client';
import axios from 'axios';
import cheerio from 'cheerio';
import moment from 'moment';
import { Scrollbars } from 'react-custom-scrollbars';

const { Header, Sider, Content } = Layout;
const { Text } = Typography;
const { SubMenu } = Menu;

class UserLayout extends Component {
  constructor(props) {
    super(props);
    this.state = {
      language: i18n.language,
      resizeWidth: window.innerWidth,
      sizeMobile: 576,
      collapsed: false,
      visible: false,
    }
  };

  // fetchDataNotification = async () => {
  //   const { userInfo } = this.props;
  //   let count = 0;
  //   const response = await feedServices.getNotification();
  //   for (let i = 0; i < response.data.length; i++) {
  //     response.data[i].readed = response.data[i].read_by.filter(k => k.userId == userInfo._id).length > 0 ? true : false;
  //     if(response.data[i].readed == false && moment(response.data[i].pubDate).isAfter(moment().add(-1, 'M'))) {
  //       count += 1;
  //     }
  //   }
  //   this.setState({
  //     notifData: response.data,
  //     countNoti: count
  //   })
  // }

  componentDidMount = () => {
    window.addEventListener('resize', this.handleResize);
    const { userInfo, getNotifications, onCurrentUser } = this.props;
    this.props.setDarkMode(true);
    this.socket = SocketIO(config.socket);
    this.socket.on('feedChange', async () => {
      const token = localStorage.getItem('TOKEN');
      if(token){
        await onCurrentUser(token);
      }
      getNotifications(userInfo._id)
    })
    getNotifications(userInfo._id)
  }


  handleResize = (e) => {
    this.setState({
      resizeWidth: window.innerWidth
    })
  }

  toggleDrawer = () => {
    this.setState({
      visible: !this.state.visible,
      collapsed: false,
    });
  };

  toggle = () => {
    this.setState({
      collapsed: !this.state.collapsed,
    });
  };

  handleLogOut = () => {
    const { onLogOut } = this.props;
    onLogOut();
    this.setState({
      visible: false,
    });
  }

  changeLanguage = (lng) => {
    i18n.changeLanguage(lng);
    this.setState({
      language: lng
    });
  }

  linkToDetail =async (id) => {
    const { userInfo, getNotifications } = this.props;
    await feedServices.updateReadBy(id, userInfo._id);
    getNotifications(userInfo._id);
    // const enttrongLink = 'https://www.enttrong.com';
    // const sangfansLink = 'https://www.sangfans.com';
    // const feedURL = id.includes(enttrongLink) ? enttrongLink : sangfansLink;
    // if(feedURL == enttrongLink) {
    // } else {
    //   await feedServices.updateReadBy(id, userInfo._id);
    //   getNotifications(userInfo._id);
    // }
    this.props.history.push(`/feed/feedDetail`, { id: id})
  }

  render() {
    const { darkMode, setDarkMode, currentPath, userInfo, t, i18n, feed } = this.props;
    const { collapsed, visible, resizeWidth, sizeMobile, language } = this.state;
    let pathSnippets = null;
    if (currentPath && currentPath.path) {
      pathSnippets = currentPath.path.split('/').filter(i => i);
    }
    const extraBreadcrumbItems = pathSnippets && pathSnippets.map((_, index) => {
      const url = `/${pathSnippets.slice(0, index + 1).join('/')}`;
      return (
        <Breadcrumb.Item key={url}>
          <Link to={url}>{t(url.toLowerCase())}</Link>
        </Breadcrumb.Item>
      );
    });
    const breadcrumbItems = [
      <Breadcrumb.Item href="/">
        <Link to="/"><Icon type="home" style={{position: 'relative', top: -3}}/></Link>
      </Breadcrumb.Item>
    ].concat(extraBreadcrumbItems && extraBreadcrumbItems);

    const listAccount = (
      (userInfo) &&
      <List
        itemLayout="horizontal"
        className="px-3 py-3 user-account"
        style={{background: darkMode ? '#000': '#fff', borderWidth: darkMode ? 0 : 1}}
      >
        <List.Item>
          <List.Item.Meta 
          avatar={<Avatar src={userInfo.photoUrl} name={userInfo.firstname+' '+userInfo.lastname} round={true} size={!collapsed ? 70 : 50} />}
          title={!collapsed && ( <span style={{color: darkMode ? '#fff' : ''}}>{userInfo.firstname+' '+userInfo.lastname}</span> )}
          description={!collapsed && ( <span style={{color: darkMode ?'#fff': ''}}>{userInfo.email}</span> )}
          />
        </List.Item>
      </List>
    );

    const LabtopSvg = () => (
      <svg viewBox="64 64 896 896" class="" data-icon="laptop" width="1em" height="1em" fill="currentColor" aria-hidden="true">
        <path d="M956.9 845.1L896.4 632V168c0-17.7-14.3-32-32-32h-704c-17.7 0-32 14.3-32 32v464L67.9 845.1C60.4 866 75.8 888 98 888h828.8c22.2 0 37.6-22 30.1-42.9zM200.4 208h624v395h-624V208zm228.3 608l8.1-37h150.3l8.1 37H428.7zm224 0l-19.1-86.7c-.8-3.7-4.1-6.3-7.8-6.3H398.2c-3.8 0-7 2.6-7.8 6.3L371.3 816H151l42.3-149h638.2l42.3 149H652.7z"></path>
      </svg>
    );

    const FeedSvg = () => (
      <svg t="1589089157507" fill="currentColor" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="1241" width="1.3em" height="1.3em">
        <path d="M263.68 760.32m-93.013333 0a93.013333 93.013333 0 1 0 186.026666 0 93.013333 93.013333 0 1 0-186.026666 0Z" p-id="1242"></path>
        <path d="M170.666667 189.653333v120.746667c299.946667 0 543.146667 243.2 543.146666 543.146667h120.746667C834.346667 486.826667 537.173333 189.653333 170.666667 189.653333zM170.666667 430.933333v120.746667c166.613333 0 301.653333 135.253333 301.653333 301.653333h120.746667c0-233.173333-189.226667-422.4-422.4-422.4z" p-id="1243"></path>
      </svg>
    );

    const KeySvg = () => (
      <svg fill="currentColor" t="1579885315905" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="5837" data-spm-anchor-id="a313x.7781069.0.i7" width="24px" height="24px">
        <path d="M537.6 460.8c-8.533333-8.533333-8.533333-23.466667 0-34.133333l179.2-174.933334c8.533333-8.533333 25.6-8.533333 34.133333 0 8.533333 8.533333 8.533333 23.466667 0 34.133334l-179.2 174.933333c-10.666667 8.533333-25.6 8.533333-34.133333 0zM362.666667 757.333333c-25.6 0-49.066667-8.533333-68.266667-27.733333-19.2-17.066667-27.733333-40.533333-27.733333-66.133333 0-25.6 10.666667-49.066667 27.733333-66.133334 38.4-36.266667 98.133333-36.266667 136.533333 0 19.2 17.066667 27.733333 40.533333 27.733334 66.133334 0 25.6-10.666667 49.066667-27.733334 66.133333-19.2 19.2-42.666667 27.733333-68.266666 27.733333z m0-140.8c-12.8 0-25.6 4.266667-34.133334 12.8-8.533333 8.533333-14.933333 21.333333-14.933333 34.133334s4.266667 23.466667 14.933333 34.133333c19.2 19.2 49.066667 19.2 68.266667 0 8.533333-8.533333 14.933333-21.333333 14.933333-34.133333s-6.4-23.466667-14.933333-32c-8.533333-10.666667-21.333333-14.933333-34.133333-14.933334z" p-id="5838"></path>
        <path d="M396.8 885.333333c-68.266667 0-132.266667-27.733333-181.333333-76.8s-74.666667-113.066667-76.8-183.466666c0-68.266667 25.6-134.4 74.666666-183.466667 34.133333-34.133333 76.8-59.733333 121.6-70.4 38.4-8.533333 78.933333-10.666667 117.333334 0 2.133333 0 6.4 0 8.533333-2.133333L676.266667 147.2c6.4-6.4 14.933333-10.666667 25.6-8.533333l136.533333 8.533333c14.933333 0 27.733333 12.8 29.866667 27.733333l17.066666 142.933334c2.133333 8.533333-2.133333 17.066667-6.4 25.6-6.4 6.4-14.933333 10.666667-23.466666 10.666666l-64 4.266667-6.4 70.4c-2.133333 17.066667-14.933333 29.866667-32 29.866667l-55.466667-2.133334-8.533333 74.666667c-2.133333 10.666667-6.4 19.2-17.066667 25.6l-19.2 10.666667c-4.266667 2.133333-4.266667 6.4-4.266667 8.533333 17.066667 85.333333-8.533333 172.8-70.4 234.666667-49.066667 46.933333-113.066667 74.666667-181.333333 74.666666z m-2.133333-471.466666c-55.466667 0-108.8 21.333333-149.333334 64-38.4 40.533333-61.866667 93.866667-59.733333 149.333333 0 55.466667 21.333333 108.8 61.866667 149.333333 40.533333 40.533333 91.733333 61.866667 147.2 61.866667 55.466667 0 108.8-21.333333 149.333333-61.866667 55.466667-55.466667 74.666667-136.533333 53.333333-213.333333l-4.266666-12.8c-2.133333-4.266667 0-8.533333 4.266666-10.666667l40.533334-21.333333c2.133333-2.133333 4.266667-4.266667 4.266666-6.4l10.666667-98.133333c0-4.266667 4.266667-8.533333 8.533333-8.533334l70.4 2.133334c4.266667 0 8.533333-4.266667 8.533334-8.533334L746.666667 320c0-4.266667 4.266667-8.533333 8.533333-8.533333l72.533333-4.266667c4.266667 0 8.533333-4.266667 8.533334-8.533333l-12.8-98.133334c0-4.266667-4.266667-6.4-8.533334-6.4l-106.666666-6.4c-2.133333 0-4.266667 0-6.4 2.133334L473.6 422.4c-2.133333 2.133333-6.4 2.133333-8.533333 2.133333l-8.533334-2.133333c-19.2-6.4-40.533333-8.533333-61.866666-8.533333z" p-id="5839"></path>
      </svg>
    );

    const SignoutSvg = () => (
      <svg t="1579887221342" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="6574" width="16px" height="16px">
        <path d="M832.512 558.933333H516.437333a55.04 55.04 0 0 1-54.954666-55.466666c0-30.634667 24.064-55.466667 54.954666-55.466667H815.786667l-90.624-93.866667a55.125333 55.125333 0 0 1 1.706666-78.08 55.637333 55.637333 0 0 1 78.08 1.024L990.72 469.333333a55.637333 55.637333 0 0 1 6.656 84.736l-197.12 190.293334a55.125333 55.125333 0 0 1-78.08-1.706667 55.637333 55.637333 0 0 1 1.024-78.08L832.512 558.933333zM602.965333 7.082667a64 64 0 0 1-20.992 126.293333 396.544 396.544 0 0 0-65.194666-5.376C301.909333 128 128 300.117333 128 512s173.909333 384 388.778667 384c20.992 0 41.642667-1.706667 62.037333-4.864a64 64 0 1 1 19.968 126.464 524.8 524.8 0 0 1-81.92 6.4C231.424 1024 0 794.965333 0 512s231.509333-512 516.778667-512c29.098667 0 57.941333 2.389333 86.186666 7.082667z" fill="currentColor" p-id="6575"></path>
      </svg>
    );

    const EducationSvg = () => (
      <svg width="1.2em" height="1.2em" viewBox="0 0 1475 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="8016">
        <path d="M1413.994667 204.672L780.586667 7.381333a143.573333 143.573333 0 0 0-43.050667-6.485333c-15.36 0-30.165333 2.368-44.074667 6.762667L61.056 204.672c-36.288 11.264-59.733333 41.728-59.733333 77.568s23.424 66.368 59.690666 77.674667l145.770667 45.376a38.186667 38.186667 0 0 0-1.301333 9.045333l0.384 420.117333c0 55.829333 45.888 104.042667 119.658666 125.866667l34.581334 10.346667c118.144 34.922667 247.765333 52.416 377.386666 52.416s259.306667-17.493333 377.472-52.501334l34.474667-10.24c73.856-21.909333 119.744-70.08 119.744-125.866666v-424.533334a38.336 38.336 0 0 0-2.410667-9.024l147.221334-40.981333c36.266667-11.306667 59.648-41.813333 59.648-77.674667s-23.424-66.304-59.648-77.589333zM1187.413333 834.453333c0 14.634667-21.013333 35.584-61.205333 47.424l-34.517333 10.325334c-221.802667 65.621333-486.656 65.621333-708.309334 0l-34.645333-10.325334c-40.106667-11.84-61.098667-32.789333-61.098667-47.424V430.464l406.912 126.634667c12.864 4.074667 27.648 6.421333 42.986667 6.421333s30.144-2.325333 44.032-6.698667l405.802667-126.336 0.042666 403.968zM756.266667 479.018667a62.144 62.144 0 0 1-18.730667 2.816c-6.698667 0-13.141333-1.024-19.2-2.944L85.269333 282.794667 718.72 85.482667a60.8 60.8 0 0 1 18.496-2.837334h0.213333c6.677333 0.021333 13.12 1.045333 19.178667 2.986667l633.152 196.16-633.493333 197.226667z" fill="currentColor" p-id="8017"></path>
        <path d="M1350.997333 409.92h-0.042666a40.853333 40.853333 0 0 0-40.853334 40.874667V778.026667a40.896 40.896 0 0 0 81.770667 0V450.794667a40.874667 40.874667 0 0 0-40.874667-40.874667z" fill="currentColor" p-id="8018"></path>
      </svg>
    );

    const CertificateSvg  = () => (
      <svg width="1.15em" height="1.15em" fill="currentColor" t="1580455606371" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="18105">
        <path d="M956.675702 866.420926l-124.699267-275.198382c8.879948-22.859866 16.639902-28.339833 44.679737-56.379668a89.429474 89.429474 0 0 0 23.139864-86.359493c-16.579903-61.899636-16.599902-53.299687 0-115.239322a89.441474 89.441474 0 0 0-23.139864-86.359492c-45.359733-45.399733-41.039759-37.879777-57.639661-99.839413a89.359475 89.359475 0 0 0-63.219628-63.219629c-61.919636-16.579903-54.43968-12.259928-99.799413-57.619661a89.427474 89.427474 0 0 0-86.379492-23.159864c-61.739637 16.539903-53.379686 16.579903-115.239323 0A89.439474 89.439474 0 0 0 367.999163 26.205866c-45.319734 45.319734-37.859777 41.019759-99.799413 57.619661a89.359475 89.359475 0 0 0-63.219629 63.219629c-16.579903 61.919636-12.259928 54.43968-57.619661 99.799413-22.579867 22.579867-31.419815 55.519674-23.139864 86.359492 16.579903 61.899636 16.599902 53.299687 0 115.239323a89.429474 89.429474 0 0 0 23.139864 86.359492c30.199822 30.219822 36.039788 34.119799 44.679737 56.379668L67.32093 866.420926c-11.91993 26.299845 9.699943 54.879677 40.89976 54.879678 0.579997 0 1.179993-0.02 1.75999-0.04l145.719143-5.01997 100.259411 95.299439C364.899181 1020.000024 376.519113 1024 387.999045 1024c17.0599 0 33.839801-8.779948 41.099759-24.799854L511.998316 816.261221l82.899513 182.938925c7.259957 16.019906 24.039859 24.799854 41.099758 24.799854 11.499932 0 23.119864-3.999976 32.019812-12.459927l100.259411-95.299439 145.719143 5.01997c0.599996 0.02 1.179993 0.04 1.75999 0.04 31.199817-0.02 52.839689-28.579832 40.919759-54.879678zM371.459142 893.800765l-78.799536-74.879559-99.979412 3.439979 59.43965-131.179228c5.17997 2.559985 10.359939 5.13997 16.079906 6.67996 50.279704 13.479921 53.579685 11.399933 86.119493 43.939742 17.259899 17.259899 40.139764 26.199846 63.259628 26.199846 3.899977 0 7.739954-1.099994 11.619932-1.599991l-57.739661 127.399251z m47.099724-223.518686c-44.039741-44.15974-67.479603-49.599708-121.839284-64.179622-22.679867-84.599503-34.0798-91.759461-78.799537-136.479198 23.019865-85.859495 15.779907-98.759419 0-157.579073 61.919636-61.919636 62.439633-75.379557 78.819537-136.479198 58.179658-15.559909 74.139564-16.439903 136.499197-78.799537 85.239499 22.839866 98.379422 15.879907 157.579074 0 42.57975 42.57975 51.299698 55.959671 136.479198 78.799537 22.679867 84.599503 34.0798 91.759461 78.799536 136.499197-22.659867 84.599503-16.379904 96.519433 0 157.619074-42.57975 42.57975-55.959671 51.319698-78.799536 136.499197-52.539691 14.079917-76.55955 18.879889-121.859284 64.179623-62.279634-36.359786-134.039212-30.899818-186.878901-0.08z m353.017924 150.019119l-40.239763-1.379992-78.799537 74.879559-57.739661-127.399251c3.879977 0.519997 7.719955 1.599991 11.619932 1.599991 23.099864 0 45.99973-8.939947 63.259628-26.199846 32.819807-32.819807 35.619791-30.399821 86.119494-43.939742 5.699966-1.519991 10.879936-4.119976 16.079905-6.67996l59.439651 131.159229-59.739649-2.039988zM703.997188 384.003762c0-106.039377-85.959495-191.998871-191.998872-191.998871s-191.998871 85.959495-191.998871 191.998871 85.959495 191.998871 191.998871 191.998872 191.998871-85.959495 191.998872-191.998872z m-191.998872 95.999436c-52.939689 0-95.999436-43.059747-95.999435-95.999436s43.059747-95.999436 95.999435-95.999435 95.999436 43.059747 95.999436 95.999435-43.059747 95.999436-95.999436 95.999436z" p-id="18106"></path>
      </svg>
    );

    const ActivitiesSvg = () => (
      <svg width="1.15em" height="1.15em" fill="currentColor" t="1580455409729" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="16957" >
        <path d="M916.54 221.922H692.58v-62.886c0-57.988-62.048-105.188-138.382-105.188H470.16c-75.56 0-134.67 46.222-134.67 105.188v62.886H118.254c-48.952 0-87.4 34.736-87.4 78.926v168.074c0 7.704 4.274 14.918 11.066 18.56 1.822 0.908 12.818 6.722 30.952 15.404V847.02c0 22.76 16.108 47.13 40.2 47.13h798.216c24.722 0 43.908-25.278 43.908-47.13V502.886c18.14-8.682 29.136-14.496 30.882-15.472 6.866-3.644 11.066-10.788 11.066-18.562V300.848c0.07-45.73-33.894-78.926-80.604-78.926m-529.098-62.886c0-34.806 31.594-53.1 82.716-53.1h83.97c51.336 0 86.436 19.556 86.436 53.1v62.886h-253.12l-0.002-62.886zM903.18 832.812c0 1.47-1.89 4.27-3.366 5.322H126.226c-0.7-1.33-1.33-3.29-1.33-5.112V522.078c70.87 30.884 164.882 73.53 284.634 89.708v19.818c0 23.182 18.84 42.022 42.018 42.022h125.048c23.182 0 42.016-18.838 42.016-42.022v-19.748c119.758-16.248 213.766-58.894 284.64-89.778v310.734h-0.072zM461.476 631.604V526.562h105.048v105.042H461.476z m483.72-185.564c-41.178 20.516-170.418 90.83-326.656 113.308v-32.786c0-23.182-18.84-42.022-42.018-42.022H451.474c-23.178 0-42.018 18.84-42.018 42.022v32.786C253.288 537.01 124.048 466.626 82.87 446.04V300.848c0-23.108 13.114-26.904 35.382-26.904H916.54c23.462 0 28.656 4.494 28.656 26.904V446.04z" p-id="16958"></path>
      </svg>
    );

    const ProfileSvg = () => (
      <svg width="1.15em" height="1.15em" fill="currentColor" t="1580454604261" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="7028" >
        <path d="M953.394435 731.55087a308.306309 308.306309 0 0 0-50.136725-126.378331c-28.689775-38.517494-73.068071-44.659819-112.430135-47.347086-6.398255-0.447878-13.461928-0.665419-22.176351-0.665418-7.063673 0-14.191329 0.140762-21.843643 0.281523a1105.234547 1105.234547 0 0 1-22.585839 0.29432 181.710438 181.710438 0 0 1-53.195091-5.822412 20.269671 20.269671 0 0 1-12.79651-14.946324 80.618011 80.618011 0 0 1-2.636081-31.300263c1.919476-1.842697 3.838953-3.736581 5.68165-5.668853a218.820317 218.820317 0 0 0 57.200399-112.123019 114.298425 114.298425 0 0 0 33.091774-35.830227 83.599598 83.599598 0 0 0 11.772789-52.46569 62.894845 62.894845 0 0 0-42.369244-50.878923c0-35.062437 1.126093-66.644223-9.955684-100.618956a219.421753 219.421753 0 0 0-50.162319-83.932308A205.051272 205.051272 0 0 0 512.081203 0.03839h-0.396692a205.563133 205.563133 0 0 0-148.96417 64.161699l-31.837716-8.957556-18.426974 46.144214-45.93947-25.311497c-4.606744 18.426974 34.550576 155.938268 34.550576 155.938268 0 4.696319 0 10.237208-0.076779 16.289957a63.125183 63.125183 0 0 0-43.508133 51.339597 83.70197 83.70197 0 0 0 11.759993 52.46569 114.592745 114.592745 0 0 0 35.830227 37.749704 220.547846 220.547846 0 0 0 57.238788 109.474141c1.90668 1.983459 3.838953 3.838953 5.809615 5.809615a80.835552 80.835552 0 0 1-2.559302 31.991275 20.282468 20.282468 0 0 1-12.796509 14.946323 181.787218 181.787218 0 0 1-53.195091 5.822412c-7.473162 0-15.151068-0.140762-22.58584-0.29432-7.217232-0.127965-14.690393-0.281523-21.754067-0.281523-8.72722 0-15.7653 0.217541-22.201944 0.665419-39.362064 2.738453-83.74036 8.880778-112.430135 47.347086a308.485461 308.485461 0 0 0-50.162318 126.37833A321.819424 321.819424 0 0 0 72.431518 869.471652a24.1982 24.1982 0 0 0 3.51904 7.537144c1.1005 1.586767 27.883595 39.234099 95.525945 75.678559a549.942803 549.942803 0 0 0 132.443876 49.176987 877.085575 877.085575 0 0 0 203.374929 22.009996 22.150758 22.150758 0 0 0 4.709116-0.51186 21.920421 21.920421 0 0 0 4.696319 0.51186 877.328709 877.328709 0 0 0 203.400523-22.009996 549.930007 549.930007 0 0 0 132.443876-49.176987 294.997939 294.997939 0 0 0 95.525945-75.678559 24.927601 24.927601 0 0 0 3.51904-7.537144 321.845017 321.845017 0 0 0 1.804308-137.920782z m-232.896478-448.466481a30.417304 30.417304 0 0 1 13.065237 20.832718 54.538725 54.538725 0 0 1-13.065237 40.091465zM300.593286 345.006699a57.315567 57.315567 0 0 1-13.833027-41.089592 30.4301 30.4301 0 0 1 14.076161-21.562119c-0.153558 27.397327-0.243134 54.730672-0.243134 62.651711z m46.848023-0.460674v-100.209468a182.990089 182.990089 0 0 0 102.461653-52.951957l-8.471289 52.670434 70.380803-52.823992-10.377969 52.760009 80.98911-52.798399a576.713102 576.713102 0 0 0 89.908278 48.409197v104.93138c0 96.088992-71.289356 174.288463-162.438895 174.314055s-162.490081-78.212268-162.490081-174.301259z m222.991979 385.853159l-21.754067-85.736616 34.550576-62.191037H450.158892l34.550577 62.191037-22.086776 87.016267-70.316821-150.640513a74.974751 74.974751 0 0 0 16.725038-28.625793 104.214775 104.214775 0 0 0 3.570226-13.999381 199.471994 199.471994 0 0 0 97.138306 26.488775 12.694138 12.694138 0 0 0 4.094883 0 201.250709 201.250709 0 0 0 97.317457-26.092083 104.137996 104.137996 0 0 0 3.467854 13.653876 71.417321 71.417321 0 0 0 22.854566 34.128291z" p-id="7029" fill="currentColor"></path>
      </svg>
    );

    const ManageTemplateSvg = () => (
      <svg t="1583869238355" fill="currentColor" class="icon" viewBox="0 0 1068 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="1201" width="1.2em" height="1.2em"><path d="M834.084316 554.731796l0 340.447776L100.813363 895.179572 100.813363 161.907596l0 0L441.261139 161.907596 441.261139 109.533219 100.813363 109.533219C71.886641 109.533219 48.437962 132.980875 48.437962 161.907596l0 733.270953c0 28.926721 23.448679 52.375401 52.375401 52.375401L834.084316 947.55395c28.925698 0 52.375401-23.448679 52.375401-52.375401L886.459716 554.731796 834.084316 554.731796 834.084316 554.731796zM559.493754 406.738733 179.624535 406.738733 179.624535 339.225319l379.869219 0L559.493754 406.738733zM713.592967 596.055976 178.09007 596.055976l0-67.513415 535.502897 0L713.592967 596.055976zM744.280232 789.389427 179.624535 789.389427l0-67.513415 564.655696 0L744.280232 789.389427z" p-id="1202"></path><path d="M936.621395 244.460819l-19.950098 0c-8.265654 0-17.012108-6.447824-19.469299-14.333954l-10.347413-25.129431c-3.885267-7.269275-2.283285-17.996212 3.526202-23.834342l14.158002-14.132428c2.358985-2.3641 3.829003-5.633534 3.829003-9.242597 0-3.611109-1.448535-6.876452-3.829003-9.250781l-24.025638-23.984719c-2.358985-2.361031-5.61819-3.820819-9.219069-3.820819s-6.878498 1.467972-9.240551 3.820819l-14.15391 14.15391c-5.810509 5.830969-16.57632 7.430905-23.854801 3.524156l-25.108971-10.334114c-7.851349-2.438777-14.328839-11.201598-14.328839-19.461115L784.607009 92.460755c0-3.334905-1.273606-6.68004-3.826957-9.229299C778.225678 80.677083 774.890773 79.399385 771.555868 79.399385l-33.929079 0c-3.351273 0-6.686178 1.277698-9.239528 3.832072-2.550282 2.550282-3.831049 5.895417-3.831049 9.229299l0 19.974649c0 8.259516-6.417135 17.022338-14.305311 19.461115L685.120448 142.230633c-7.295872 3.906749-18.004396 2.324204-23.812859-3.524156L647.094346 124.561774c-2.363077-2.3641-5.639672-3.809566-9.240551-3.809566-3.599856 0-6.859061 1.466949-9.223161 3.819796l-23.96426 23.96426c-2.3641 2.363077-3.813658 5.623305-3.830026 9.230322 0 3.601902 1.466949 6.870314 3.830026 9.234414l14.133451 14.161071c5.847337 5.849383 7.449319 16.568136 3.524156 23.834342l-10.344344 25.148867c-2.440823 7.888176-11.184208 14.337023-19.449862 14.337023l-19.969534-0.022505c-3.351273 0-6.685155 1.278721-9.235437 3.833095-2.554374 2.553351-3.831049 5.895417-3.831049 9.240551l0 33.920895c0 3.343089 1.276675 6.686178 3.831049 9.241574 2.550282 2.544144 5.884164 3.819796 9.235437 3.819796l19.969534 0c8.265654 0.018414 16.991648 6.467261 19.430426 14.334977l10.36378 25.129431c3.888336 7.287688 2.30579 18.044292-3.524156 23.852755l-14.173347 14.136519c-2.3641 2.363077-3.830026 5.629443-3.830026 9.248735 0 3.600879 1.466949 6.876452 3.830026 9.240551l24.025638 23.985742c2.358985 2.3641 5.61819 3.819796 9.218046 3.819796 3.601902 0 6.880543-1.456719 9.242597-3.819796l14.172324-14.14368c5.813578-5.823808 16.51801-7.421698 23.776032-3.478122l25.18774 10.33616c7.888176 2.449007 14.305311 11.192392 14.305311 19.457023l0 19.910202c0 3.333882 1.276675 6.686178 3.831049 9.23646 2.553351 2.53596 5.888256 3.812635 9.239528 3.812635l33.911688 0c3.351273 0 6.686178-1.276675 9.240551-3.812635 2.553351-2.550282 3.830026-5.902577 3.830026-9.23646l0-19.910202c0-8.263608 6.474422-17.006993 14.32577-19.457023l25.14989-10.33616c7.275413-3.942553 18.01974-2.341594 23.870146 3.478122l14.079233 14.133451c2.361031 2.373307 5.620236 3.849463 9.241574 3.849463 3.599856 0.009207 6.878498-1.447512 9.23646-3.820819l24.025638-24.004156c2.380468-2.373307 3.829003-5.640695 3.829003-9.247712 0-3.612132-1.465926-6.878498-3.829003-9.241574l-14.154933-14.136519c-5.813578-5.812555-7.410446-16.565067-3.525179-23.852755l10.343321-25.129431c2.457191-7.866693 11.242517-14.316563 19.472368-14.316563l19.947029 0c3.334905 0 6.66981-1.277698 9.220092-3.831049 2.553351-2.554374 3.830026-5.89644 3.830026-9.238505l0-33.931125c0-3.345135-1.276675-6.687201-3.830026-9.240551C943.291205 245.73954 939.9563 244.460819 936.621395 244.460819L936.621395 244.460819zM754.637874 349.483732c-41.453075 0-75.043548-33.567968-75.043548-75.014905 0-41.438753 33.590474-75.024112 75.043548-75.024112 41.439776 0 75.027181 33.585359 75.027181 75.024112C829.665055 315.915764 796.07765 349.483732 754.637874 349.483732L754.637874 349.483732zM1067.859117 150.88195" p-id="1203"></path></svg>
    );

    const BarSvg = () => (
      <svg width="1.15em" height="1.15em" fill="currentColor" t="1580461746390" class="icon" viewBox="0 0 1258 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="7958">
        <path d="M26.91643 0h1259.279059v192.813176H26.91643zM26.91643 403.757176h1259.279059v192.813177H26.91643zM26.91643 831.849412h1259.279059v192.813176H26.91643z" p-id="7959"></path>
      </svg>
    );

    const breadcrumbSeparator = (
      <svg width="8" height="8" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-circle "><g><circle cx="12" cy="12" r="10"></circle></g></svg>
    );

    const DarkSvg = () => (
      <svg width="1em" height="1em" fill="currentColor"  t="1580978512795" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="5249">
        <path d="M510.918492 1024c-268.025899 0-487.830647-205.627589-510.847959-467.517105a47.797952 47.797952 0 0 1 84.216559-28.61294c0.258621 0.399688 0.68182 0.141066 0.68182-0.963953a309.663957 309.663957 0 0 0 226.317307 97.970519 313.496258 313.496258 0 0 0 313.54328-313.519768 309.710979 309.710979 0 0 0-98.934472-227.281261c0.141066-0.141066 0.68182-0.141066 0.423199-0.399687A48.268173 48.268173 0 0 1 556.694494 0c261.74845 23.299444 467.234973 242.963126 467.234973 510.965514 0 283.425633-229.608853 513.034486-513.010975 513.034486z" p-id="5250"></path>
      </svg>
    );

    const NewsSvg = () => (
      <svg t="1583365669333" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="6435" width="22" height="22">
        <path d="M0 0h1024v1024H0z" fill="#ffffff" p-id="6436"></path>
        <path d="M631.776 800h32v-32h-32v32z m-256 0v-32h-32v32h32z m490.304-67.264l-31.808 3.52 31.808-3.52zM158.304 729.6l31.68 4.608-31.68-4.608zM608 178.88h-32v21.056l19.328 8.32 12.672-29.376zM763.424 384h32v-3.168l-0.64-3.104-31.36 6.272zM260.576 384l-31.36-6.272-0.32 1.536-0.16 1.536 31.84 3.2zM416 178.912l12.672 29.408 19.328-8.32V178.88h-32z m441.184 532.224l-26.304 18.24 26.304-18.24zM763.424 576h-32v10.016l5.696 8.224 26.304-18.24zM164.32 713.28l-27.904-15.68 27.904 15.68zM241.28 576l27.904 15.68 3.264-5.856 0.672-6.624-31.84-3.2z m655.648-199.744a32 32 0 0 0 62.08 15.52l-62.08-15.552z m-120.16-311.04a32 32 0 1 0-17.6 61.568l17.6-61.568zM62.24 391.776a32 32 0 1 0 62.08-15.552l-62.08 15.552zM262.08 126.784a32 32 0 1 0-17.6-61.568l17.6 61.568zM599.776 800a96 96 0 0 1-96 96v64a160 160 0 0 0 160-160h-64z m-96 96a96 96 0 0 1-96-96h-64a160 160 0 0 0 160 160v-64z m-128-64h256v-64h-256v64zM209.28 832H814.72v-64H209.28v64z m605.376 0c28.768 0 52.512-12.704 67.392-33.856 14.112-20.096 18.432-45.216 15.808-68.96l-63.616 7.072c1.344 12-1.376 20.544-4.576 25.12-2.496 3.52-6.4 6.624-15.04 6.624v64zM126.656 725.024c-3.552 24.384 0.128 50.4 14.08 71.36C155.424 818.496 179.648 832 209.28 832v-64c-8.768 0-12.736-3.2-15.296-7.04-3.296-4.96-5.856-14.144-4.032-26.72l-63.36-9.216zM448 160a64 64 0 0 1 64-64V32a128 128 0 0 0-128 128h64z m64-64a64 64 0 0 1 64 64h64a128 128 0 0 0-128-128v64z m83.328 112.32c53.312 22.976 87.616 67.2 108.96 108.16 10.56 20.32 17.6 39.104 21.984 52.8a275.072 275.072 0 0 1 5.568 20.032l0.192 0.896a1.12 1.12 0 0 1 0 0.128v-0.032l31.392-6.304 31.36-6.304V377.6l-0.032-0.16-0.096-0.512a338.24 338.24 0 0 0-7.392-27.104 401.408 401.408 0 0 0-26.208-62.88c-25.056-48.064-68.48-106.368-140.384-137.408l-25.344 58.784zM640 178.88V160h-64v18.912h64zM260.576 384a4585.088 4585.088 0 0 1 31.36 6.304v-0.096a75.328 75.328 0 0 1 1.216-4.96c0.928-3.68 2.4-9.152 4.576-16 4.352-13.664 11.392-32.448 21.952-52.736 21.376-40.96 55.68-85.216 108.992-108.192l-25.344-58.784C331.392 180.576 288 238.88 262.944 286.944a401.472 401.472 0 0 0-26.176 62.88 337.728 337.728 0 0 0-7.52 27.616l-0.032 0.16v0.096l31.36 6.304zM448 178.912V160h-64v18.912h64z m435.488 513.984l-93.76-135.136-52.576 36.48 93.76 135.136 52.576-36.48zM795.424 576v-192h-64v192h64z m-603.2 152.928l76.992-137.28-55.808-31.296-76.992 137.28 55.808 31.296z m80.96-149.76l19.2-192-63.68-6.368-19.2 192 63.68 6.4z m624.704 150.016a79.392 79.392 0 0 0-14.4-36.288l-52.608 36.48a17.248 17.248 0 0 1 3.392 6.88l63.616-7.04z m-707.904 5.056a17.344 17.344 0 0 1 2.24-5.312L136.416 697.6a79.616 79.616 0 0 0-9.76 27.424l63.328 9.216zM959.04 391.744c36.16-144.704-53.632-289.76-182.24-326.528l-17.6 61.568c95.36 27.232 165.568 138.176 137.76 249.472l62.08 15.52z m-834.72-15.52C96.512 264.96 166.72 154.048 262.08 126.816l-17.6-61.568C115.872 102.016 26.08 247.04 62.24 391.808l62.08-15.552z" fill="currentColor" p-id="6437"></path>
      </svg>
    );

    const LightSvg = () => (
      <svg width="1em" height="1em" fill="currentColor" t="1580980728280" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="8662">
        <path d="M512 160c17.664 0 32-14.336 32-32L544 32C544 14.336 529.664 0 512 0 494.336 0 480 14.336 480 32L480 128C480 145.664 494.336 160 512 160z" p-id="8663"></path>
        <path d="M217.856 263.104c12.48 12.48 32.768 12.48 45.248 0 12.48-12.48 12.48-32.768 0-45.248L195.2 149.952c-12.48-12.48-32.768-12.48-45.248 0-12.48 12.48-12.48 32.768 0 45.248L217.856 263.104z" p-id="8664"></path>
        <path d="M160 512c0-17.664-14.336-32-32-32L32 480C14.336 480 0 494.336 0 512c0 17.664 14.336 32 32 32L128 544C145.664 544 160 529.664 160 512z" p-id="8665"></path>
        <path d="M806.144 263.104l67.904-67.904c12.48-12.48 12.48-32.768 0-45.248s-32.768-12.48-45.248 0l-67.904 67.904c-12.48 12.48-12.48 32.768 0 45.248C773.376 275.584 793.664 275.584 806.144 263.104z" p-id="8666"></path>
        <path d="M992 480 896 480c-17.664 0-32 14.336-32 32 0 17.664 14.336 32 32 32l96 0C1009.664 544 1024 529.664 1024 512 1024 494.336 1009.664 480 992 480z" p-id="8667"></path>
        <path d="M512 512m-288.192 0a4.503 4.503 0 1 0 576.384 0 4.503 4.503 0 1 0-576.384 0Z" p-id="8668"></path><path d="M806.144 760.896c-12.48-12.48-32.768-12.48-45.248 0-12.48 12.48-12.48 32.768 0 45.248l67.904 67.904c12.48 12.48 32.768 12.48 45.248 0 12.48-12.48 12.48-32.768 0-45.248L806.144 760.896z" p-id="8669"></path><path d="M217.856 760.896 149.952 828.8c-12.48 12.48-12.48 32.768 0 45.248 12.48 12.48 32.768 12.48 45.248 0l67.904-67.904c12.48-12.48 12.48-32.768 0-45.248C250.624 748.416 230.336 748.416 217.856 760.896z" p-id="8670"></path><path d="M512 864c-17.664 0-32 14.336-32 32l0 96C480 1009.664 494.336 1024 512 1024c17.664 0 32-14.336 32-32L544 896C544 878.336 529.664 864 512 864z" p-id="8671"></path>
      </svg>
    );

    const TimeSvg = () => (
      <svg fill="currentColor" t="1583369362220" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="5773" width="12" height="12"><path d="M505.984 975.317333c-259.2 0-469.333333-210.133333-469.333333-469.333333s210.133333-469.333333 469.333333-469.333333 469.333333 210.133333 469.333333 469.333333S765.226667 975.317333 505.984 975.317333zM505.984 124.672c-210.602667 0-381.354667 170.709333-381.354667 381.354667 0 210.602667 170.709333 381.354667 381.354667 381.354667 210.602667 0 381.354667-170.752 381.354667-381.354667C887.338667 295.381333 716.586667 124.672 505.984 124.672zM696.661333 550.016l-88.021333 0-58.666667 0-43.989333 0 0 0c-24.32 0-43.989333-19.712-43.989333-43.989333L461.994667 242.005333c0-24.277333 19.669333-43.989333 43.989333-43.989333 24.277333 0 43.989333 19.712 43.989333 43.989333l0 219.989333 58.666667 0 88.021333 0c24.277333 0 43.989333 19.712 43.989333 43.989333S720.938667 550.016 696.661333 550.016z" p-id="5774"></path></svg>
    );

    const EducationIcon = props => <Icon component={EducationSvg} {...props} />;
    const CertificateIcon = props => <Icon component={CertificateSvg} {...props} />;
    const ActivitiesIcon = props => <Icon component={ActivitiesSvg} {...props} />;
    const LabtopIcon = props => <Icon component={LabtopSvg} {...props} />;
    const KeyIcon = props => <Icon component={KeySvg} {...props} />;
    const SignOutIcon = props => <Icon component={SignoutSvg} {...props} />;
    const ProfileIcon = props => <Icon component={ProfileSvg} {...props} />;
    const BarIcon = props => <Icon component={BarSvg} {...props} />;
    const DarkIcon = props => <Icon component={DarkSvg} {...props} />;
    const LightIcon = props => <Icon component={LightSvg} {...props} />;
    const FeedIcon = props => <Icon component={FeedSvg} {...props} />;
    const NewIcon = props => <Icon component={NewsSvg} {...props} />;
    const TimeIcon = props => <Icon component={TimeSvg} {...props} />;
    const ManageTemplateIcon = props => <Icon component={ManageTemplateSvg} {...props} />;

    const slideBar = (
        <Sider style={{
          overflow: 'initial',
          position: resizeWidth < sizeMobile ? '': 'fixed',
          left: 0,
          minHeight: '100vh'
        }} theme={darkMode ? 'dark' : 'light'} trigger={null} collapsible collapsed={this.state.collapsed} width={270} reverseArrow={true}>
          <Scrollbars style={{height: '100vh'}}>
            <div className="logo position-relative" style={{borderRight: darkMode ? 'none' :'1px solid #e8e8e8' }}>
              <img style={{paddingLeft: !collapsed ? 20 : 30}} className="mr-2" src={require('../assets/logo.png')} />
              {!collapsed && ([
                <Text strong className=" mr-4" style={{fontSize: 16, color: darkMode? '#fff': '#0051cb'}}>Tum Port</Text>,
                <Button onClick={() => setDarkMode(!darkMode)} className="position-absolute d-flex align-item-center justify-content-center m-0" style={{right: '1rem'}} size="small" ghost={darkMode? true : false} type="dashed" shape="circle" >
                  { darkMode ? <DarkIcon /> : <LightIcon /> }
                </Button>
              ])}
            </div>
            {/* <Divider type="horizontal" className="my-0"/> */}
            {listAccount}
            {/* <Divider type="horizontal" className="my-0"/> */}
            <Menu theme={darkMode ? 'dark' : 'light'} mode="inline" selectedKeys={[this.props.currentPath.path]} style={{maxHeight: '70%'}}>
              <Menu.ItemGroup key="g1" title={!collapsed && (<Tag style={{fontSize: 12, borderRadius: 12}} className="text-uppercase my-2 mr-3 px-3" color={darkMode ?'#000':'#ccc'}>{t('lbl_main')}</Tag>)}>
                { userInfo && !userInfo.admin &&
                <Menu.Item onClick={() => this.setState({visible: false})} key="/" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/">
                    <Icon type="home" style={{fontSize: 16, position: 'relative', top: -3, marginRight: 18}}/>
                    <span>{t('lbl_home')}</span>
                  </Link>
                </Menu.Item>
                }
                { userInfo && !userInfo.admin &&
                <Menu.Item onClick={() => this.setState({visible: false})} key="/template" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/template">
                    <LabtopIcon style={{fontSize: 16, position: 'relative', top: -3, marginRight: 18}}/>
                    <span>{t('lbl_template')}</span>
                  </Link>
                </Menu.Item>
                }
                { userInfo && userInfo.admin &&
                  <Menu.Item onClick={() => this.setState({visible: false})} key="/manageTemplate" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                    <Link to="/manageTemplate">
                      <ManageTemplateIcon style={{fontSize: 16, position: 'relative', top: -3, marginRight: 18}}/>
                      <span>{t('lbl_manage_template')}</span>
                    </Link>
                  </Menu.Item>
                }
                {userInfo && !userInfo.admin &&
                <Menu.Item onClick={() => this.setState({visible: false})} key="/feed" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/feed">
                    <FeedIcon style={{fontSize: 16, position: 'relative', top: -3, marginRight: 12}} />
                    <span>{t('lbl_feed')}</span>
                    { !userInfo.readNewFeed &&
                      <img src={require('../assets/images/new.gif')} className={collapsed ? 'ml-3' : 'ml-1'} style={{width: 35, position: 'relative', top: -3}}/>
                    }
                  </Link>
                </Menu.Item>
                }
              </Menu.ItemGroup>
              {userInfo && !userInfo.admin &&
              <Menu.ItemGroup key="g2" title={!collapsed && (<Tag style={{fontSize: 12, borderRadius: 12}} className="text-uppercase my-2 mr-3 px-3" color={ darkMode ? '#000' : '#ccc'}>{t('lbl_informations')}</Tag>)}>
                <Menu.Item onClick={() => this.setState({visible: false})} key="/profile" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/profile">
                    <Icon type="user" style={{fontSize: 16, position: 'relative', top: -3, marginRight: 18}}/>
                    <span>{t('lbl_profile')}</span>
                  </Link>
                </Menu.Item>
                <Menu.Item onClick={() => this.setState({visible: false})} key="/education" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/education">
                    <EducationIcon style={{fontSize: 16, position: 'relative', top: -3, left: -2, marginRight: 14}}/>
                    <span>{t('lbl_education')}</span>
                  </Link>
                </Menu.Item>
                <Menu.Item onClick={() => this.setState({visible: false})} key="/activities" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/activities">
                    <ActivitiesIcon style={{fontSize: 16, position: 'relative', top: -3, left: -2, marginRight: 16}}/>
                    <span>{t('lbl_activities')}</span>
                  </Link>
                </Menu.Item>
                <Menu.Item onClick={() => this.setState({visible: false})} key="/certificate" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/certificate">
                    <CertificateIcon style={{fontSize: 16, position: 'relative', top: -3, left: -2, marginRight: 16}}/>
                    <span>{t('lbl_certificate')}</span>
                  </Link>
                </Menu.Item>
              </Menu.ItemGroup>
              }
              <Menu.ItemGroup key="g3" title={!collapsed && (<Tag style={{fontSize: 12, borderRadius: 12}} className="text-uppercase my-2 mr-3 px-3" color={ darkMode ? '#000' : '#ccc'}>{t('lbl_account')}</Tag>)}>
                {userInfo && !userInfo.admin &&
                  <Menu.Item onClick={() => this.setState({visible: false})} key="/settingNotifications" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                    <Link to="/settingNotifications">
                      <Icon type="setting" style={{fontSize: 18, position: 'relative', top: -3, marginRight: 14}}/>
                      <span>{t('/settingnotifications')}</span>
                    </Link>
                  </Menu.Item>
                }
                {(userInfo && userInfo.providerId === 'password') && 
                <Menu.Item onClick={() => this.setState({visible: false})} key="/changePassword" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                  <Link to="/changePassword">
                    <KeyIcon style={{fontSize: 16, position: 'relative', top: -3, marginRight: 10}}/>
                    <span>{t('lbl_change_password')}</span>
                  </Link>
                </Menu.Item>
                }
                <Menu.Item onClick={this.handleLogOut} key="signIn" style={collapsed && {width: 80}} className="d-inline-flex align-items-center py-3">
                    <SignOutIcon style={{fontSize: 16, position: 'relative', top: 0, marginRight: 18}}/>
                    <span>{t('lbl_sign_out')}</span>
                </Menu.Item>
              </Menu.ItemGroup>
            </Menu>
          </Scrollbars>
        </Sider>
    );

    const menuLange = (
      <Menu>
        <Menu.Item className="py-2 d-flex align-items-center" onClick={() => this.changeLanguage('th-TH')}>
          <img src={require('../assets/flags/th-TH.svg')} style={{width: 25, alignSelf: 'center'}}/>&nbsp;
          {t('lbl_thai')}
        </Menu.Item>
        <Menu.Item className="py-2 d-flex align-items-center" onClick={() => this.changeLanguage('en-US')}>
          <img src={require('../assets/flags/en-US.svg')} style={{width: 25}}/>&nbsp;
          {t('lbl_english')}
        </Menu.Item>
      </Menu>
    );

    const headerNotifDropdown = (
      <List
        className="noti-feed-dropdown p-0"
        itemLayout="horizontal"
        header={<div className="px-3 py-2 font-weight-bold">{t('lbl_notification')}</div>}
        footer={<Button block style={{borderRadius: 0}} className="text-center shadow-0" onClick={() => this.props.history.push('/feed')}>{t('lbl_see_all')}</Button>}
        bordered
        style={{width: resizeWidth < sizeMobile ? resizeWidth : 350}}
        locale={{emptyText: (<Empty image={Empty.PRESENTED_IMAGE_SIMPLE} description={t('lbl_no_data')} />)}}
        dataSource={feed.data}
        renderItem={(item, index) => {
          if(index < 20) {
          return (
            <List.Item className="position-relative" style={{backgroundColor: item.readed ? '#ffffff' : '#f3f4f5',}} onClick={() => this.linkToDetail(item._id)}>
              <List.Item.Meta
                avatar={<img className="w-60" src={item.logo} />}
                title={item.title}
                description={[<TimeIcon className="position-relative mr-1" style={{top: -3}}/>, moment(item.date).locale(i18n.language == 'en-US' ?'en': 'th').add(543, 'years').format('LLL')]}
              
              />
            </List.Item>
            )
          } else return <React.Fragment />;
        }}
      />
    );

    return (
      <Layout className="user-layout" style={{minHeight: '100vh'}}>
        {resizeWidth < sizeMobile ?
        <Drawer
          title={null}
          placement="left"
          closable={false}
          onClose={() => this.setState({visible: false})}
          visible={visible}
          width={270}
          className="drawer-user-layout user-layout"
        >
          {slideBar}
        </Drawer>
        :
        slideBar}
        <Layout style={ (resizeWidth >= sizeMobile) ? { marginLeft: !collapsed  ? 270: 80, overflow: 'initial', transition: 'all .2s'} : {}}>
          <Header style={{ background: '#fff', padding: '0 2rem' }} className="header-user-layout position-relative">
            <div className="header-bar">
              <BarIcon
                className="trigger"
                onClick={resizeWidth < sizeMobile ? this.toggleDrawer : this.toggle}
              />
              <Link to="/"><img style={{paddingLeft: 12, height: 30, cursor: 'pointer'}} className="mr-2 header-img-icon" src={require('../assets/logo.png')} /></Link>
              <Breadcrumb separator={breadcrumbSeparator}>
                {breadcrumbItems}
              </Breadcrumb>
            </div>
            <div className="header-action">
              {resizeWidth < sizeMobile ?
                <Badge count={feed.count} className="mx-2 cursor-pointer" onClick={() => this.props.history.push('/feed')}>
                  <NewIcon
                    style={{cursor: "pointer", fontSize: 18}}
                  />
                </Badge>
              :
                <Dropdown overlay={headerNotifDropdown} trigger={["click"]}>
                  <Badge count={feed.count} className="mx-2 cursor-pointer">
                    <NewIcon
                      style={{cursor: "pointer", fontSize: 18}}
                    />
                  </Badge>
                </Dropdown>
              }
              <Dropdown overlay={menuLange} placement="bottomRight" className="ml-3">
                {resizeWidth >= sizeMobile ? 
                  <a className="ant-dropdown-link text-dark d-inline-flex align-items-center ml-3" href="#">
                    <img src={require('../assets/flags/'+language+'.png')} style={{width: 30}}/>&nbsp;
                    {t("lbl_"+language)}
                  </a>
                  : 
                  <Icon
                    type="global"
                    style={{cursor: "pointer", fontSize: 18}}
                  />
                }
              </Dropdown>
            </div>
          </Header>
          <Content>
            {this.props.children}
          </Content>
        </Layout>
      </Layout>
    );
  }
}

const mapStateToProps = (state) => ({
  userInfo: state.auth.user,
  currentPath: state.currentPath,
  darkMode: state.darkMode.dark,
  feed: state.feed
})

const mapDispatchToProps = dispatch => {
  return {
    onLogOut: () => dispatch(logOut()),
    setDarkMode: (isDarkMode) => dispatch(setDarkMode(isDarkMode)),
    getNotifications: (userId) => dispatch(getNotifications(userId)),
    onCurrentUser: (token) => dispatch(currentUser(token)),
  }
}

export default withRouter(withTranslation()(connect(mapStateToProps, mapDispatchToProps)(UserLayout)))